<template>
  <div class="app-container">
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="success"
          icon="el-icon-s-promotion"
          size="mini"
          @click="handleApprove"
          v-if="isApprove==0"
        >发起审批
        </el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="patrolList" @selection-change="handleSelectionChange" :height="clientHeight"
              border>
      <el-table-column type="selection" width="55" align="center"/>
      <el-table-column label="巡检类型" align="center" prop="planType" :show-overflow-tooltip="true" :formatter="patrolTypeFormatter"/>
      <el-table-column label="巡检状态" align="center" prop="planStatus" :show-overflow-tooltip="true" >
        <template slot-scope="scope">
          <el-tag v-if="scope.row.planStatus==0" type="info">未确认</el-tag>
          <el-tag v-if="scope.row.planStatus==1">待确认</el-tag>
          <el-tag v-if="scope.row.planStatus==2" type="success">已确认</el-tag>
        </template>
      </el-table-column>
      <el-table-column label="确认人" align="center" prop="confirm1Name" :show-overflow-tooltip="true"/>
      <el-table-column label="确认时间" align="center" prop="confirmDate">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.confirmDate, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="备注" align="center" prop="remarks" :show-overflow-tooltip="true"/>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改巡检对话框 -->
    <el-dialog :close-on-click-modal="false" :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="巡检类型" prop="planType">
          <el-select v-model="form.planType" placeholder="请选择巡检类型">
            <el-option
              v-for="item in mainList"
              :key="item.patrolType"
              :label="item.devName"
              :value="item.patrolType"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="备注" prop="remarks">
          <el-input v-model="form.remarks" placeholder="请输入备注"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <!-- 批量修改对话框 -->
    <el-dialog :close-on-click-modal="false" title="批量修改" :visible.sync="openBatch" width="500px" append-to-body>
      <el-form ref="form" :model="form" label-width="80px">
        <el-form-item>
          <span>已选择 {{ ids.length }} 条数据</span>
        </el-form-item>
        <el-form-item label="确认人1" prop="confirm1Name"
                      v-if="isApprove==0">
          <el-select v-model="form.confirm1Name" clearable filterable style="width: 100%;"
                     placeholder="请选择确认人1">
            <el-option v-for="user in userOptions"
                       :label="user.nickName"
                       :value="user.userId+''"
                       :key="user.userId"/>
          </el-select>
        </el-form-item>

        <el-form-item label="时间"  v-hasPermi="['pssr:date:edit']" prop="confirmationDate">
          <el-date-picker clearable size="small" style="width: 200px"
                          v-model="form.confirmationDate"
                          type="date"
                          value-format="yyyy-MM-dd"
                          placeholder="选择时间">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="备注" prop="remarks">
          <el-input v-model="form.remarks" placeholder="请输入备注"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitFormBatch">确 定</el-button>
        <el-button @click="cancelBatch">取 消</el-button>
      </div>
    </el-dialog>
      <!-- 用户导入对话框 -->
    <el-dialog :close-on-click-modal="false" :title="upload.title" :visible.sync="upload.open" width="400px"
               append-to-body>
      <el-upload
        ref="upload"
        :limit="1"
        accept=".xlsx, .xls"
        :headers="upload.headers"
        :action="upload.url + '?updateSupport=' + upload.updateSupport"
        :disabled="upload.isUploading"
        :on-progress="handleFileUploadProgress"
        :on-success="handleFileSuccess"
        :auto-upload="false"
        drag
      >
        <i class="el-icon-upload"></i>
        <div class="el-upload__text">
          将文件拖到此处，或
          <em>点击上传</em>
        </div>
        <div class="el-upload__tip" slot="tip">
          <el-checkbox v-model="upload.updateSupport"/>
          是否更新已经存在的用户数据
          <el-link type="info" style="font-size:12px" @click="importTemplate">下载模板</el-link>
        </div>
        <div class="el-upload__tip" style="color:red" slot="tip">提示：仅允许导入“xls”或“xlsx”格式文件！</div>
      </el-upload>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitFileForm">确 定</el-button>
        <el-button @click="upload.open = false">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  addPatrol,
  delPatrol,
  exportPatrol,
  getPatrol,
  importTemplate,
  listPatrol,
  updatePatrol,
  updatePatrolBatch,
} from "@/api/pssr/patrol";
import {treeselect} from "@/api/system/dept";
import {getToken} from "@/utils/auth";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
import {listAllMain} from "@/api/patrol/patrol/main";
import {updateMaterialBatch} from "@/api/pssr/material";
import {doApprove} from "@/api/pssr/approve";

export default {
  dicts: ['pssr_approve_status'],
  name: "Patrol",
  components: {Treeselect},
  props: {
    subId: {
      type: Number,
      default: 0
    },
    isApprove: {
      type: Number,
      default: 0
    },
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: false,
      // 总条数
      total: 0,
      // 巡检表格数据
      patrolList: [],
      mainList: [],
      // 弹出层标题
      title: "",
      // 部门树选项
      deptOptions: undefined,
      clientHeight: 300,
      // 是否显示弹出层
      open: false,
      openBatch: false,
      // 用户导入参数
      upload: {
        // 是否显示弹出层（用户导入）
        open: false,
        // 弹出层标题（用户导入）
        title: "",
        // 是否禁用上传
        isUploading: false,
        // 是否更新已经存在的用户数据
        updateSupport: 0,
        // 设置上传的请求头部
        headers: {Authorization: "Bearer " + getToken()},
        // 上传的地址
        url: process.env.VUE_APP_BASE_API + "/pssr/patrol/importData"
      },
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 20,
        subId: this.subId,
        approveId: null,
        planId: null,
        planType: null,
        planStatus: null,
        confirmer: null,
        confirmDate: null,
        createrCode: null,
        createdate: null,
        updaterCode: null,
        updatedate: null,
        deptId: null,
        remarks: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {}
    };
  },
  watch: {
    // 根据名称筛选部门树
    deptName(val) {
      this.$refs.tree.filter(val);
    }
  },
  created() {
    //设置表格高度对应屏幕高度
    this.$nextTick(() => {
      this.clientHeight = document.body.clientHeight - 350
    })
    this.getList();
    this.getTreeselect();
    this.getMainList();
  },
  methods: {
    patrolTypeFormatter(row){
      let devName = "";
      this.mainList.forEach(item=>{
        if (row.planType==item.patrolType){
          devName= item.devName
        }
      })
      if (row.planType=='27'){
        return "急救箱检查记录"
      }
      return devName;
    },
    getMainList() {
      let year = new Date().getFullYear();
      listAllMain({year: year}).then(response => {
        this.mainList = response.data;
      });
    },
    /** 查询巡检列表 */
    getList() {
      this.loading = true;
      listPatrol(this.queryParams).then(response => {
        this.patrolList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    /** 查询部门下拉树结构 */
    getTreeselect() {
      treeselect().then(response => {
        this.deptOptions = response.data;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        subId: this.subId,
        approveId: null,
        planId: null,
        planType: null,
        planStatus: 0,
        confirmer: null,
        confirmDate: null,
        delFlag: null,
        createrCode: null,
        createdate: null,
        updaterCode: null,
        updatedate: null,
        deptId: null,
        remarks: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加巡检";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getPatrol(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改巡检";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updatePatrol(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addPatrol(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },

    /** 确认按钮操作*/
    handleApprove() {
      doApprove(this.subId).then(res => {
        this.msgSuccess("已发起确认流程");
        this.getList();
      })
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function () {
        return delPatrol(ids);
      }).then(() => {
        this.getList();
        this.msgSuccess("删除成功");
      })
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有巡检数据项?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function () {
        return exportPatrol(queryParams);
      }).then(response => {
        this.download(response.msg);
      })
    },
    /** 导入按钮操作 */
    handleImport() {
      this.upload.title = "用户导入";
      this.upload.open = true;
    },
    /** 下载模板操作 */
    importTemplate() {
      importTemplate().then(response => {
        this.download(response.msg);
      });
    },
    // 文件上传中处理
    handleFileUploadProgress(event, file, fileList) {
      this.upload.isUploading = true;
    },
    // 文件上传成功处理
    handleFileSuccess(response, file, fileList) {
      this.upload.open = false;
      this.upload.isUploading = false;
      this.$refs.upload.clearFiles();
      this.$alert(response.msg, "导入结果", {dangerouslyUseHTMLString: true});
      this.getList();
    },
    // 提交上传文件
    submitFileForm() {
      this.$refs.upload.submit();
    },
    handleBatch(){
      this.reset();
      this.openBatch = true
    },
    // 取消按钮
    cancelBatch() {
      this.openBatch = false;
      this.reset();
    },
    /** 提交按钮 */
    submitFormBatch() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          this.form.ids = this.ids
          updatePatrolBatch(this.form).then(response => {
            this.msgSuccess("修改成功");
            this.openBatch = false;
            this.getList();
          });
        }
      });
    },
  }
};
</script>
